<?php get_header(); ?>

<?php require_once( 'slider.php' ); ?>

<section class="our-services">
    <div class="container">
        <div class="center">
            <h2 class="sec-title"><?php the_field( 'about-h', 'options' ); ?></h2>
            <hr class="fancy">
        </div>
        <p class="sec-des"><?php the_field( 'about-p', 'options' ); ?></p>
        <br>
        <ul class="list-inline text-center">
			<?php while ( have_rows( 'home-servs', 'options' ) ) : the_row(); ?>
				<?php $singlePost = get_sub_field( 'choose-home-serv', 'options' ); ?>

				<?php $post = $singlePost;
				setup_postdata( $post ); ?>
                <li><a href="<?php the_permalink(); ?>"><img src="<?php the_sub_field( 'service-home-img' ); ?>" alt="">
                        <p><?php the_title() ?></p></a></li>
			<?php endwhile;
			wp_reset_postdata(); ?>
        </ul>
    </div>
</section>

<section class="what-do-you-know">
    <div class="container">
        <div class="col-md-7">
            <h2 class="sec-title"><?php the_field( 'about-h1', 'options' ); ?></h2>
            <p class="sec-des"><?php the_field( 'about-desc', 'options' ); ?></p>

            <ul class="list-inline text-center">
				<?php while ( have_rows( 'about-features', 'options' ) ) : the_row(); ?>
                    <li>
                        <img src="<?php the_sub_field( 'about-f-icon', 'options' ); ?>" alt="">
                        <h3><?php the_sub_field( 'about-f-h', 'options' ); ?></h3>
                        <p><?php the_sub_field( 'about-f-p', 'options' ); ?></p>
                    </li>
				<?php endwhile; ?>

            </ul>
        </div>
        <div class="col-md-5">
            <div id="about" class="carousel slide" data-ride="carousel">
                <!-- Indicators -->
                <ol class="carousel-indicators">
					<?php

					$images = get_field( 'about-gallery', 'options' );
					$i      = 0;
					foreach ( $images as $image ): ?>
                        <li data-target="#about" data-slide-to="<?php echo $i ++; ?>"></li>
					<?php endforeach; ?>
                </ol>

                <!-- Wrapper for slides -->
                <div class="carousel-inner">
					<?php

					$images = get_field( 'about-gallery', 'options' );

					if ( $images ): ?>
						<?php foreach ( $images as $image ): ?>
                            <div class="item ">
                                <img src="<?php echo $image['sizes']['large']; ?>"
                                     alt="<?php echo $image['alt']; ?>"/>

                            </div>
						<?php endforeach; ?>

					<?php endif; ?>


                </div>


            </div>
        </div>
    </div>
</section>
<section class="works">
    <div class="container">
        <div class="center">
            <h2 class="sec-title"><?php the_field( 'latest-h', 'options' ); ?></h2>
            <hr class="fancy">
            <p class="sec-des"><?php the_field( 'latest-p', 'options' ); ?></p>
        </div>
        <br>

		<?php $terms = get_terms( 'works-sections', array( 'hide_empty' => true ) ); ?>

        <div class="center">
<!--            <div class="filter" data-filter="all">الكل</div>-->
			<?php foreach ( $terms as $term ) : ?>
                <div class="filter" data-filter=".<?= $term->term_id; ?>"><?= $term->name; ?></div>
			<?php endforeach; ?>

        </div>
        <br><br><br>
        <div id="Container" class="center">

			<?php $termsIds = array(); ?>
			<?php foreach ( $terms as $term ) :
				$termsIds = $term->term_id;
				?>
				<?php $WG = new WP_Query( array(
				'post_type'      => 'latest-work',
				'posts_per_page' => 6,
				'tax_query'      => array(
					array(
						'taxonomy' => 'works-sections',
						'field'    => 'term_id',
						'terms'    => $termsIds,
					),
				),
			) ); ?>
				<?php while ( $WG->have_posts() ) : $WG->the_post(); ?>

                <div class="single_project mix <?= $term->term_id; ?>">
                    <a href="">
                        <div class="back center">
                            <a href="<?php the_permalink(); ?>"><i class="fa fa-link fa-2x"></i></a>
                            <a href="<?php the_post_thumbnail_url( 'full' ); ?>" rel="lightbox"><i
                                        class="fa fa-expand fa-2x"></i></a>
                            <p><?php the_title(); ?></p>
                        </div>

						<?php echo get_the_post_thumbnail( $post->ID, 'large', array( 'class' => 'img-responsive' ) ); ?>
                    </a>
                </div>
			<?php endwhile; ?>
			<?php endforeach; ?>


        </div>
    </div>
</section>


<section class="order-common" data-type="background" data-speed="2">
    <div class="container">
        <div class="col-md-8">
            <h4><?php the_field('CONTACT-H','options'); ?></h4>
            <p><?php the_field('contact-p','options'); ?></p>

        </div>
        <div class="col-md-2">
            <br>
            <a href="<?php the_field('contact-btn-url','options'); ?>" class="btn btn-warning btn-block">اطلب خدمة الآن</a>
        </div>
        <div class="col-md-2">
            <br>
            <a href="<?php the_field('contact-btn-url2','options'); ?>" class="btn btn-danger btn-block">اطلب عرض سعر</a>
        </div>
    </div>
</section>
<section class="clients">
    <div class="container">
        <div class="center">
            <h2 class="sec-title"><?php the_field( 'ourc-h', 'options' ); ?></h2>
            <hr class="fancy">
            <p class="sec-des"><?php the_field( 'ourc-p', 'options' ); ?></p>
        </div>
        <br>

        <div class="clients-slider">
			<?php $args = array(
				'post_type'      => 'clients',
				'posts_per_page' => 20

			);
			$clients    = new WP_Query( $args ); ?>
			<?php while ( $clients->have_posts() ) : $clients->the_post(); ?>
                <div class="single-client">
                    <a href="<?php the_field( 'client-url' ); ?>">
                        <?php echo get_the_post_thumbnail( $post->ID, 'large', array( 'class' => 'img-responsive' ) ); ?>
                    </a>
                </div>
			<?php endwhile;
			wp_reset_query(); ?>

        </div>
    </div>
</section>


<?php get_footer(); ?>
