<?php
/* Template Name: Blog */
get_header();
wp_reset_query(); ?>

<div class="gap custom-gap"></div>
<div class="breadcrumb" typeof="BreadcrumbList" vocab="http://schema.org/">
    <div class="container">
		<?php if ( function_exists( 'bcn_display' ) ) {
			bcn_display();
		} ?>
    </div>
</div>
<div class="page-blog-full">
    <div class="container">
        <div class="row">
	        <?php
	        global $paged;
	        if ( get_query_var( 'paged' ) ) {
		        $my_page = get_query_var( 'paged' );
	        } else {
		        if ( get_query_var( 'page' ) ) {
			        $my_page = get_query_var( 'page' );
		        } else {
			        $my_page = 1;
		        }
		        set_query_var( 'paged', $my_page );
		        $paged = $my_page;
	        }; ?>
	        <?php $postsQuery = array(
		        'post_type'      => 'post',
		        'posts_per_page' => 9,
		        'paged'          => $my_page
	        );
	        $allPosts         = new WP_Query( $postsQuery );
	        while ( $allPosts->have_posts() ) : $allPosts->the_post(); ?>
            <div class="col-md-4 col-sm-6">
                <div <?php post_class('single-blog-post') ;?>>

	                <?php
	                if ( get_the_post_thumbnail() ) :
		                echo get_the_post_thumbnail( $post->id, 'full', array( 'class' => 'img-responsive' ) );
	                else : ?>
                        <img src="<?php echo IMAGES; ?>/no-img.png" alt="<?php the_title(); ?> "
                             class="img-responsive">
	                <?php endif; ?>
                        <div class="row">
                            <div class="col-xs-3">
                                <div class="post-time text-center">
                                    <p><?php echo get_the_date('j'); ?></p>
                                    <p><?php echo get_the_date('F'); ?></p>
                                </div>
                            </div>
                            <div class="col-xs-9">
                                <h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
                                <p><?php echo wp_trim_words(get_the_excerpt(),40,''); ?></p>
                            </div>
                        </div>

                </div>
            </div>
	        <?php endwhile; ?>
            <div class="center">
		        <?php wp_pagenavi( array( 'query' => $allPosts ) );; ?>
            </div>
        </div>
    </div>
</div>

<br><br><br><br>
<section class="order-common" data-type="background" data-speed="2">
    <div class="container">
        <div class="col-md-8">
            <h4><?php the_field('CONTACT-H','options'); ?></h4>
            <p><?php the_field('contact-p','options'); ?></p>

        </div>
        <div class="col-md-2">
            <br>
            <a href="<?php the_field('contact-btn-url','options'); ?>" class="btn btn-warning btn-block">اطلب خدمة الآن</a>
        </div>
        <div class="col-md-2">
            <br>
            <a href="<?php the_field('contact-btn-url2','options'); ?>" class="btn btn-danger btn-block">اطلب عرض سعر</a>
        </div>
    </div>
</section>
<?php get_footer(); ?>
